function [IMFs,residue, upper_envelopes, lower_envelopes, sift_counter] = emd_lars(signal)
    signal_length = length(signal); 
    counter_outer = 1;
    counter_inner = 1;
    cubic_spline_counter = 0;
    sift_counter = [];
    while(1)
        tmp_signal = signal;

        if(alreadyResidue(tmp_signal))
            residue = tmp_signal;
            break
        end

        while(1)
            cubic_spline_counter = cubic_spline_counter +1; 
            if(IMF_check(tmp_signal))
                sift_counter = [sift_counter, counter_inner-1];
                counter_inner = 1;
                break
            end
            [yMax, xMax] = findpeaks(flip(tmp_signal));
            yMax = flip([tmp_signal(signal_length), yMax, tmp_signal(1)]);
            xMax = flip([signal_length , signal_length - (xMax-1), 1]);
           
            upper_envelope = Cubic_spline_LARS(xMax,yMax,1:signal_length);
            upper_envelopes(cubic_spline_counter,:) = upper_envelope;
            
            [yMax, xMax] = findpeaks(flip(-tmp_signal));
            yMax = flip([-tmp_signal(signal_length), yMax, -tmp_signal(1)]);
            xMax = flip([signal_length , signal_length - (xMax-1), 1]);
            yMax = -yMax;

            lower_envelope = Cubic_spline_LARS(xMax,yMax,1:signal_length);
            lower_envelopes(cubic_spline_counter,:) = lower_envelope;

            mean_envelope = (upper_envelope + lower_envelope)/2;
            
            tmp_signal = tmp_signal - mean_envelope;
            if(counter_inner == 1000)
                error('Could not find anny IMFs');
            end
            counter_inner = counter_inner +1;
        end
        IMFs(counter_outer,:) = tmp_signal;
        
        signal = signal - tmp_signal;
        if(counter_outer == 100)
            error('Residue not found');
        end
        counter_outer = counter_outer +1;

    end
end
