% Reads the IMFs from "file_name.dat"
% Inputs:
%        file_name: File name containing the different IMF components
%    signal_length: Number of samples in each IMF.

function [IMFs, nr_of_IMFs]  = translate_file_from_quartus(file_name,signal_length)

    max_IMFs = log2(signal_length);
    IMFs = zeros(max_IMFs,signal_length);
    file = fopen(file_name, 'r');
    assert(file ~= -1, 'Could not open %s. File not found.',file_name);
    for nr_of_IMFs = 0:max_IMFs-1
        for k = 1:signal_length
            a = fgetl(file);
            if(a == -1)
                return;
            end
            IMFs(nr_of_IMFs+1,k) = str2num(a);
        end
    end
    fclose(file);
end
